/* Processed by ecpg (4.7.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "stateeventsdb.ec"
/* 
 * State changes databse infrastructure.
 * Copyright (C) 2009 Petr Kubanek <petr@kubanek.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "xmlrpcd.h"

#include "rts2db/sqlerror.h"


#line 1 "/usr/include/postgresql/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef PGDLLIMPORT
#if  defined(WIN32) || defined(__CYGWIN__)
#define PGDLLIMPORT __declspec (dllimport)
#else
#define PGDLLIMPORT
#endif   /* __CYGWIN__ */
#endif   /* PGDLLIMPORT */

#define SQLERRMC_LEN	150

#ifdef __cplusplus
extern		"C"
{
#endif

struct sqlca_t
{
	char		sqlcaid[8];
	long		sqlabc;
	long		sqlcode;
	struct
	{
		int			sqlerrml;
		char		sqlerrmc[SQLERRMC_LEN];
	}			sqlerrm;
	char		sqlerrp[8];
	long		sqlerrd[6];
	/* Element 0: empty						*/
	/* 1: OID of processed tuple if applicable			*/
	/* 2: number of rows processed				*/
	/* after an INSERT, UPDATE or				*/
	/* DELETE statement					*/
	/* 3: empty						*/
	/* 4: empty						*/
	/* 5: empty						*/
	char		sqlwarn[8];
	/* Element 0: set to 'W' if at least one other is 'W'	*/
	/* 1: if 'W' at least one character string		*/
	/* value was truncated when it was			*/
	/* stored into a host variable.				*/

	/*
	 * 2: if 'W' a (hopefully) non-fatal notice occurred
	 */	/* 3: empty */
	/* 4: empty						*/
	/* 5: empty						*/
	/* 6: empty						*/
	/* 7: empty						*/

	char		sqlstate[5];
};

struct sqlca_t *ECPGget_sqlca(void);

#ifndef POSTGRES_ECPG_INTERNAL
#define sqlca (*ECPGget_sqlca())
#endif

#ifdef __cplusplus
}
#endif

#endif

#line 24 "stateeventsdb.ec"


using namespace rts2xmlrpc;

void StateChangeRecord::run (XmlRpcd *_master, rts2core::Connection *_conn, double validTime)
{
	/* exec sql begin declare section */
	   
	 
	 
	 
	   
	
#line 31 "stateeventsdb.ec"
 int db_recval_id = dbValueId ;
 
#line 32 "stateeventsdb.ec"
  struct varchar_1  { int len; char arr[ 25 ]; }  db_device_name ;
 
#line 33 "stateeventsdb.ec"
  struct varchar_2  { int len; char arr[ 25 ]; }  db_value_name ;
 
#line 34 "stateeventsdb.ec"
 int db_value ;
 
#line 35 "stateeventsdb.ec"
 double db_rectime = validTime ;
/* exec sql end declare section */
#line 36 "stateeventsdb.ec"


	if (db_recval_id < 0)
	{
		db_device_name.len = strlen (_conn->getName ());
		if (db_device_name.len > 25)
			db_device_name.len = 25;
		strncpy (db_device_name.arr, _conn->getName (), db_device_name.len);

		db_value_name.len = 5;
		strncpy (db_value_name.arr, "state", db_value_name.len);
		{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select recval_id from recvals where device_name = $1  and value_name = $2 ", 
	ECPGt_varchar,&(db_device_name),(long)25,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_value_name),(long)25,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 48 "stateeventsdb.ec"

		if (sqlca.sqlcode)
		{
			if (sqlca.sqlcode == ECPG_NOT_FOUND)
			{
				// insert new record
				{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select nextval ( 'recval_ids' )", ECPGt_EOIT, 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 54 "stateeventsdb.ec"

				{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into recvals values ( $1  , $2  , $3  , 0 )", 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_device_name),(long)25,(long)1,sizeof(struct varchar_1), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_varchar,&(db_value_name),(long)25,(long)1,sizeof(struct varchar_2), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 55 "stateeventsdb.ec"

				if (sqlca.sqlcode)
					throw rts2db::SqlError ();
			}
			else
			{
				throw rts2db::SqlError ();
			}
		}
	}
	
	db_value = _conn->getState () & getChangeMask ();
	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into records_state values ( $1  , to_timestamp ( $2  ) , $3  )", 
	ECPGt_int,&(db_recval_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(db_rectime),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(db_value),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 73 "stateeventsdb.ec"

	{ ECPGtrans(__LINE__, NULL, "commit");}
#line 74 "stateeventsdb.ec"

	if (sqlca.sqlcode)
	{
		throw rts2db::SqlError ();
	}
}
